#!/bin/bash
#Installer of NA AGENT on LINUX
#Date		Description
#24/01/2011	NA Agent Setup Version 1.0.RC5
#               

USER_ID=$(id -u)
	if [ $USER_ID -ne 0 ];then
       		echo "Kindly ensure NA Agent Installation is done using \"root\" login."
       		exit
	fi

NA=NA

rm -f "/tmp/NA_AGENT_InstallationDetails.log"
value=$?
if [ $value -ne 0 ]; then
	echo "Error while deletion in log file NA_AGENT_InstallationDetails.log"
	exit
fi

#Na agent installation logs files.
touch "/tmp/NA_AGENT_InstallationDetails.log"
LOG="/tmp/NA_AGENT_InstallationDetails.log"

#It holds the Installation Versions
AGENT_VERSION=1.06
AGENT_INSTALLER_VERSION=1.06
AGENT_UNINSTALLER_VERSION=1.01
AGENT_MONITORING_VERSION=1.01
AGENT_STATUS_FLAG=0
BROKER_ID=

#It holds the Installation directory of NA
InstallDir="/usr/bin/$NA"

>$LOG

#It holds the NA Registry file path
REGISTRY_FILE="/etc/na_agent_registry.txt"
REGISTRY_DIRECTORY="/etc/NA_REGISTRY"
#REGISTRY_FILE="$REGISTRY_DIRECTORY/$BROKER_ID"
#It holds the setup zip file name which contains all setup files.
Setup_zip_file="NA_AGENT_"$AGENT_INSTALLER_VERSION"_SetupFiles.zip"

#SetupFilesPath is the path for na agent zip extraction.
SetupFilesPath="/tmp/NA_Agent_Files" 2>>$LOG

#Flags used to decide whether fresh or upgrade of agent installation.
UPGRADE_FLAG=0
AGENT_UNINSTALLER_UPGRADE_FLAG=0
AGENT_MONITORING_UPGRADE_FLAG=0

#Header in the repo config file
PATHS_PARAM=PATHS
NUMBER_OF_LOGS_PARAM=NUMBER_OF_LOGS

#Headers in the na registry file
ROOT_NAME=ROOT
SECTION_NAME=SECTION
VERSION_NAME=VERSION

#Parameters from the registry file under VERSION header
AGENT_UNINSTALLER_VERSION_PARAM=AGENT_UNINSTALLER_VERSION
AGENT_VERSION_PARAM=AGENT_VERSION
AGENT_MONITORING_VERSION_PARAM=AGENT_MONITORING_VERSION

#Parameters from the registry file under ROOT header
VERSION_PARAM="VERSION"
PATH_PARAM="PATH"
REPO_CONFIG_FILE_PATH_PARAM="REPO_CONFIG_FILE_PATH"
CONFIG_FILE_PATH_PARAM="CONFIG_FILE_PATH"
NA_AGENT_PATH_PARAM="NA_AGENT_PATH"
BROKER_ID_PARAM="BROKER_ID"

# Value of Repository index NA_REPO_MAX_INDEX
NUMBER_OF_LOGS=20
AGENT_INDEX=13

#It holds the path for cron entry
CRON_USER="root"
PATH_FOR_CRON_ENTRY="/var/spool/cron/root"

#It holds the time for cron to run
TASK_EXEC_TIME_MONITORING="00 02 * * *"
TASK_EXEC_TIME_MONITORING_ONREBOOT="@reboot"
TASK_COMMAND_MONITORING="$InstallDir/NA_AGENT/BIN/restart_agent_monitoring.sh"
TASK_COMMAND_RESTART_MONITORING="$InstallDir/NA_AGENT/restart_agent_monitoring.sh"
NA_REPO_INI="$InstallDir/NA_REPO_MANAGEMENT/CONFIG/na_repo.ini"


function Status_check()
{
#      	echo "------------------------------------START NA_AGENT---------------------------------" | tee -a $LOG
#	echo "Installing NA Agent." |tee -a $LOG
      	echo "------------------------------------START NA_AGENT---------------------------------" >> $LOG
 	echo "Installing NA Agent." >> $LOG
	# Check if NA is installed or not on this machine.
	#if [ ! -f /etc/na_registry.txt ];then
    #    echo "Error while installation - na_registry file not found" |tee -a $LOG
	#	exit
	#fi

	 #Check if NA is installed or not on this machine.
	if [ ! -f "$REGISTRY_DIRECTORY/$BROKER_ID" ];then
        echo "Error while installation - na_registry $REGISTRY_DIRECTORY/$BROKER_ID file not found" |tee -a $LOG
		exit
	fi


	mkdir -p $SetupFilesPath  2>>$LOG
	if [ ! -d $SetupFilesPath ];then
		echo "Cannot create SetupFilesPath directory." | tee -a $LOG
		exit
	fi

	unzip -o $Setup_zip_file -x -d $SetupFilesPath >>$LOG
	value=$?
	if [ $value -ne 0 ];then
		echo "Cannot unzip $Setup_zip_file." | tee -a $LOG
		exit
	fi
	echo "All files extracted" >> $LOG
	cd "$SetupFilesPath/exe"
	chmod -R 777 "$SetupFilesPath" >> $LOG
	echo "All permissions granted to Setup Files" >> $LOG

}

function AbortInstall()
{
	if [  $UPGRADE_FLAG -eq 1 ]; then

		# kill agent monitoring if running
		process_count=`/bin/ps ax |/bin/grep -w agent_monitoring_service.sh|grep -v "grep"|wc -l`
		if [ $process_count -ne 0 ] ;then
			process_id=`/bin/ps ax |/bin/grep -w agent_monitoring_service.sh|grep -v "grep"|awk '{ print $1 }' ` >>$LOG 2>>$LOG
			value=$?
			if [ $value -ne 0 ]; then
				echo "PID detection of agent_monitoring_service failed.Return value: $value" | tee -a $LOG
			fi
			kill -9 $process_id 2>>$LOG
		fi

		# kill na agent if running

		process_count=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|wc -l`
		if [ $process_count -ne 0 ] ;then
			process_id=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|awk '{ print $1 }' ` >>$LOG 2>>$LOG
			value=$?
			if [ $value -ne 0 ]; then
				echo "PID detection of na_agent failed.Return value: $value" | tee -a $LOG
			fi
			kill -9 $process_id 2>>$LOG

		fi
	fi

#	Cleanup of AGENT
	rm -Rf "$InstallDir/NA_AGENT"
	rm -Rf "$REGISTRY_FILE"
	echo "NA AGENT Installation failed." | tee -a $LOG

	echo "Removing schedular entries" >> $LOG
	echo "Copy of cron entry is kept at /tmp/cron_backup" >> $LOG
	cp -f $PATH_FOR_CRON_ENTRY "/tmp/cron_backup"
	sed '/restart_agent_monitoring.sh/d' $PATH_FOR_CRON_ENTRY > /tmp/new_cron_file.txt
	diff $PATH_FOR_CRON_ENTRY /tmp/new_cron_file.txt >> $LOG

	cp -f /tmp/new_cron_file.txt $PATH_FOR_CRON_ENTRY
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copy of /tmp/new_cron_file.txt to the $PATH_FOR_CRON_ENTRY failed: Return value: $value" | tee -a $LOG
		echo "Reverting back /tmp/cron_backup to $PATH_FOR_CRON_ENTRY" | tee -a $LOG
		cp -f /tmp/cron_backup $PATH_FOR_CRON_ENTRY >> $LOG
		echo "NA agent installation failed." | tee -a $LOG
	fi

	# NA_REPO_INI entries removal from repo_ini file of na
	cp $NA_REPO_INI /tmp/repo_ini_bkp.txt 2>>$LOG
	
	sed   '/NA_AGENT/d' $NA_REPO_INI > /tmp/new_repo_file.txt 2>>$LOG
	cp /tmp/new_repo_file.txt $NA_REPO_INI

	value=$?
	if [ $value -ne 0 ]; then
		echo "Copy of /tmp/new_repo_file.txt to the $NA_REPO_INI failed: Return value: $value" | tee -a $LOG
		echo "Reverting back /tmp/repo_ini_bkp.txt to $NA_REPO_INI" | tee -a $LOG
		cp -f /tmp/repo_ini_bkp.txt $NA_REPO_INI 2>> $LOG
		echo "Remove repository entry of na agent manually" | tee -a $LOG
	fi		
	OnExitInstall
}
function OnExitInstall()
{
	#Cleanup activites to be done here
	rm -Rf "$SetupFilesPath" >>$LOG
	echo "SetupFiles cleaned up." >> $LOG
	chmod -R 777 "$InstallDir/NA_AGENT" >> $LOG 2>>$LOG
	chmod -R 777 $REGISTRY_FILE >> $LOG 2>>$LOG
#	echo "-------------------------------------END NA_AGENT----------------------------------" | tee -a $LOG
	echo "-------------------------------------END NA_AGENT----------------------------------" >> $LOG

	exit
}

function Oninit()
{	
	if [ ! -f $REGISTRY_FILE ];then
		echo "NA agent registry file is not present." >> $LOG
		UPGRADE_FLAG=0
	else
	#	Upgrade Case of na agent
		./config_utility -sg "$REGISTRY_FILE" "$VERSION_NAME" "$AGENT_VERSION_PARAM" 2>>$LOG
		value=$?
		if [ $value -ne 0 ];then
			echo "Cannot find VERSION_NAME entry in registry file" | tee -a $LOG
			UPGRADE_FLAG=0
		else
			registry_value=`cat tap_val.txt`2>>$LOG
			echo -n $(cat tap_val.txt |cut -d "." -f 1)>na_agent.txt
			echo -n $(cat tap_val.txt |cut -d "." -f 2)>>na_agent.txt
			CURRENT_VERSION=`cat na_agent.txt`

			echo -n $(echo $AGENT_VERSION |cut -d "." -f 1)>na_agent.txt
			echo -n $(echo $AGENT_VERSION |cut -d "." -f 2)>>na_agent.txt
			AGENT_VERSION_NEW=`cat na_agent.txt`

			if [ $CURRENT_VERSION -lt $AGENT_VERSION_NEW ];then
				UPGRADE_FLAG=1
			else
				echo "You have the latest version of na agent" >>$LOG  2>> $LOG
				process_count=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|wc -l`
				if [ $process_count -ne 0 ] ;then
					process_id=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|awk '{ print $1 }' ` >>$LOG 2>>$LOG
					kill -9 $process_id 2>>$LOG
					value=$?
					if [ $value -ne 0 ]; then
						echo "Kill of na_agent failed. Return value: $value" | tee -a $LOG
						AbortInstall 
					fi
				fi

				OnExitInstall
			fi

			#Agent Uninstaller
			./config_utility -sg "$REGISTRY_FILE" "$VERSION_NAME" "$AGENT_UNINSTALLER_VERSION_PARAM" 2>>$LOG
			value=$?
			if [ $value -ne 0 ];then
				echo "Cannot find Agent Uninstaller entry in registry file" | tee -a $LOG
				Abortinstall 0
			fi

			registry_value=`cat tap_val.txt` >>$LOG
			echo -n $(cat tap_val.txt |cut -d "." -f 1)>na_agent.txt
			echo -n $(cat tap_val.txt |cut -d "." -f 2)>>na_agent.txt

			CURRENT_VERSION=`cat na_agent.txt`

			echo -n $(echo $AGENT_UNINSTALLER_VERSION |cut -d "." -f 1)>na_agent.txt
			echo -n $(echo $AGENT_UNINSTALLER_VERSION |cut -d "." -f 2)>>na_agent.txt
			AGENT_UNINSTALLER_VERSION_NEW=`cat na_agent.txt`

			if [ $CURRENT_VERSION -lt $AGENT_UNINSTALLER_VERSION_NEW ];then
				AGENT_UNINSTALLER_UPGRADE_FLAG=1
			else
				#echo "You have the latest version of na agent uninstaller " | tee -a $LOG
				echo "You have the latest version of na agent uninstaller " >> $LOG
				echo "Uninstaller UPGRADE_FLAG = $AGENT_UNINSTALLER_UPGRADE_FLAG which is default value" >>$LOG
			fi
			
			#Agent Monitoring
			./config_utility -sg "$REGISTRY_FILE" "$VERSION_NAME" "$AGENT_MONITORING_VERSION_PARAM" 2>>$LOG
			value=$?
			if [ $value -ne 0 ];then
				echo "Cannot find Agent Monitoring entry in registry file" | tee -a $LOG
				Abortinstall
			fi
			
			registry_value=`cat tap_val.txt`2>>$LOG
			echo -n $(cat tap_val.txt |cut -d "." -f 1)>na_agent.txt
			echo -n $(cat tap_val.txt |cut -d "." -f 2)>>na_agent.txt

			CURRENT_VERSION=`cat na_agent.txt`

			echo -n $(echo $AGENT_MONITORING_VERSION |cut -d "." -f 1)>na_agent.txt
			echo -n $(echo $AGENT_MONITORING_VERSION |cut -d "." -f 2)>>na_agent.txt
			AGENT_MONITORING_VERSION_NEW=`cat na_agent.txt`

			if [ $CURRENT_VERSION -lt $AGENT_MONITORING_VERSION_NEW ];then
				AGENT_MONITORING_UPGRADE_FLAG=1
				echo  "Monitoring  UPGRADE_FLAG = $AGENT_MONITORING_UPGRADE_FLAG" >>$LOG
				echo  "which is upgrade status of monitoring value" >>$LOG
			else
				echo "You have the latest version of na agent monitoring" >>$LOG
				AGENT_MONITORING_UPGRADE_FLAG=0
			fi
		fi
	fi
}

function Get_InstallPath ()
{
	./config_utility -sg "$REGISTRY_DIRECTORY/$BROKER_ID" "$ROOT_NAME" "$PATH_PARAM" 2>>$LOG
	value=$?
	if [ $value -ne 0 ];then
		echo "Cannot find NA installation path in na registry file" | tee -a $LOG
		exit
	fi

	InstallDir=`cat tap_val.txt`

	# Redefine following variables using new value of InstallDir

	TASK_COMMAND_MONITORING="$InstallDir/NA_AGENT/BIN/restart_agent_monitoring.sh"
	TASK_COMMAND_RESTART_MONITORING="$InstallDir/NA_AGENT/restart_agent_monitoring.sh"
	NA_REPO_INI="$InstallDir/NA_REPO_MANAGEMENT/CONFIG/na_repo.ini"
}


function PreInstall()
{

if [ $UPGRADE_FLAG -eq 1  ];then

	# AGENT_UPGRADE wrt Flag Value
	# Partial name to kill na_gaent and  agent_monitoring

	process_count=`/bin/ps ax |/bin/grep -w agent_monitoring_service.sh|grep -v "grep"|wc -l`
	if [ $process_count -ne 0 ] ;then
		process_id=`/bin/ps ax |/bin/grep -w agent_monitoring_service.sh|grep -v "grep"|awk '{ print $1 }' ` >>$LOG 2>>$LOG
		kill -9 $process_id 2>>$LOG
		value=$?
		if [ $value -ne 0 ]; then
			echo "Kill of agent_monitoring_service failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	process_count=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|wc -l`
	if [ $process_count -ne 0 ] ;then
		process_id=`/bin/ps ax |/bin/grep -w na_agent|grep -v "grep"|awk '{ print $1 }' ` >>$LOG 2>>$LOG
		kill -9 $process_id 2>>$LOG
		value=$?
		if [ $value -ne 0 ]; then
			echo "Kill of na_agent failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	rm -f "$InstallDir/NA_AGENT/BIN/na_agent"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Delete of na_agent failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	cp -pf "$SetupFilesPath/exe/na_agent" "$InstallDir/NA_AGENT/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of na_agent failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_VERSION_PARAM $AGENT_VERSION
	value=$?
	if [ $value -ne 1 ]; then
		echo "Unable to write $AGENT_VERSION_PARAM to the registry file. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

# UNINSTALLER_UPGRADE wrt Flag Value

	if [ $AGENT_UNINSTALLER_UPGRADE_FLAG -eq 1 ];then
		rm -f "$InstallDir/NA_AGENT/agent_uninstaller.sh"
		value=$?
		if [ $value -ne 0 ]; then
			echo "Delete of agent_uninstaller.sh failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	

		cp -pf "$SetupFilesPath/exe/agent_uninstaller.sh" "$InstallDir/NA_AGENT"
		value=$?
		if [ $value -ne 0 ]; then
			echo "Copying of agent_uninstaller.sh failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi

		./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_UNINSTALLER_VERSION_PARAM $AGENT_UNINSTALLER_VERSION
		value=$?
		if [ $value -ne 1 ]; then
			echo -n "Unable to write $AGENT_UNINSTALLER_VERSION_PARAM to the registry file." | tee -a $LOG
			echo   " Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi
# AGENT_MONITORING_UPGRADE wrt Flag Value

	if [ $AGENT_MONITORING_UPGRADE_FLAG -eq 1 ];then
		rm -f "$InstallDir/NA_AGENT/BIN/agent_monitoring_service.sh"
		value=$?
		if [ $value -ne 0 ]; then
			echo "Delete of agent_monitoring_service.sh failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	

		cp -pf "$SetupFilesPath/exe/agent_monitoring_service.sh" "$InstallDir/NA_AGENT/BIN"
		value=$?
		if [ $value -ne 0 ]; then
			echo "Copy of agent_monitoring_service.sh failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi

		./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_MONITORING_VERSION_PARAM $AGENT_MONITORING_VERSION
		value=$?
		if [ $value -ne 1 ]; then
			echo "Unable to write $AGENT_MONITORING_VERSION_PARAM to the registry file. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi
else
#Fresh installation case for na_agent
	# AGENT_Install wrt Flag Value
	#/usr/bin/NA_IP/NA_AGENT/
	#Read NA PATH

	#Making the registry file entries.
	if [ ! -f $REGISTRY_FILE ]; then
		echo "Creating na_agent_registry.txt file" >> $LOG
		touch "$REGISTRY_FILE"
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $REGISTRY_FILE file failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	#Install all the common tools
	if [ ! -d "$InstallDir/NA_AGENT" ]; then
		echo "Creating $InstallDir/NA_AGENT" >> $LOG
		mkdir $InstallDir/NA_AGENT
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $InstallDir/NA_AGENT directory failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi
	#Writing of PATH in the registry file
	echo "Writing of PATH in the registry file" >> $LOG

	./config_utility -sa $REGISTRY_FILE $ROOT_NAME $PATH_PARAM $InstallDir
	value=$?
	if [ $value -ne 1 ]; then
		echo "Unable to write PATH to the registry file. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	chmod -R 777 $InstallDir/NA_AGENT >> $LOG
	echo "All permissions granted" >> $LOG

	# Installation of Na_Agent services.
	if [ ! -d "$InstallDir/NA_AGENT/BIN" ]; then
		echo "Creating $InstallDir/NA_AGENT/BIN directory" >> $LOG
		mkdir -p $InstallDir/NA_AGENT/BIN
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $InstallDir/NA_AGENT/BIN directory failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	echo "Copying na_agent" >> $LOG
	cp -p "$SetupFilesPath/exe/na_agent" "$InstallDir/NA_AGENT/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of na_agent failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	NA_AGENT_PATH_FILE=$(echo $InstallDir/NA_AGENT/BIN/na_agent)
	./config_utility -sa $REGISTRY_FILE $ROOT_NAME $NA_AGENT_PATH_PARAM $NA_AGENT_PATH_FILE
	value=$?
	if [ $value -ne 1 ]; then
		echo "Unable to write NA_AGENT_PATH to the registry file. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	echo "Copying na_agent_uninstaller" >> $LOG
	cp -p "$SetupFilesPath/exe/agent_uninstaller.sh" "$InstallDir/NA_AGENT"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of agent_uninstaller.sh failed Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	echo "Copying agent_monitoring_service.sh " >> $LOG
	cp -p "$SetupFilesPath/exe/agent_monitoring_service.sh" "$InstallDir/NA_AGENT/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of agent_monitoring_service.sh failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	if [ ! -d "$InstallDir/NA_AGENT/CONFIG" ]; then
		echo "Creating $InstallDir/NA_AGENT/CONFIG directory" >> $LOG
		mkdir $InstallDir/NA_AGENT/CONFIG
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $InstallDir/NA_AGENT/CONFIG directory failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	echo "Copying na_agent.ini" >> $LOG
	cp -p "$SetupFilesPath/config/na_agent.ini" "$InstallDir/NA_AGENT/CONFIG"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of na_agent.ini failed Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	NA_AGENT_CONFIG_FILE=$(echo $InstallDir/NA_AGENT/CONFIG/na_agent.ini)
	
	#Writing of Broker ID in the configuration file
	echo "Writing of BrokerID in the configuration file" >> $LOG
	./config_utility -m $NA_AGENT_CONFIG_FILE $BROKER_ID_PARAM $BROKER_ID
    value=$?
	if [ $value -ne 1 ]; then
		echo "Cannot write $BROKER_ID_PARAM to the na_agent.ini file Return value: $value" | tee -a $LOG
		AbortInstall
	fi

	./config_utility -sa $REGISTRY_FILE $ROOT_NAME $CONFIG_FILE_PATH_PARAM \
	$NA_AGENT_CONFIG_FILE
	value=$?
	if [ $value -ne 1 ]; then
		echo "Unable to write CONFIG_FILE_PATH to the registry file. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	if [ ! -d "$InstallDir/NA_AGENT/LOGS" ]; then
		echo "Creating $InstallDir/NA_AGENT/LOGS directory" >> $LOG
		mkdir $InstallDir/NA_AGENT/LOGS
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $InstallDir/NA_AGENT/LOGS directory failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi
	
	echo "Copying restart_agent_monitoring.sh" >> $LOG
	cp -p "$SetupFilesPath/exe/restart_agent_monitoring.sh" "$InstallDir/NA_AGENT/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Copying of restart_agent_monitoring.sh failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	if [ ! -d "$InstallDir/NA_AGENT/REPOSITORY" ]; then
		echo "Creating $InstallDir/NA_AGENT/REPOSITORY directory" >> $LOG
		mkdir $InstallDir/NA_AGENT/REPOSITORY
		value=$?
		if [ $value -ne 0 ]; then
			echo "Creation of $InstallDir/NA_AGENT/REPOSITORY directory failed. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	if [ $UPGRADE_FLAG -eq 0 ]; then
		#Modifying of AGENT_VERSION_PARAM in the registry file
		echo "Modifying AGENT_VERSION_PARAM in the registry file" >> $LOG
		./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_VERSION_PARAM $AGENT_VERSION
		value=$?
		if [ $value -ne 1 ]; then
			echo "Unable to write $AGENT_VERSION_PARAM to the registry file. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	if [ $AGENT_UNINSTALLER_UPGRADE_FLAG -eq 0 ]; then
		#Modifying of AGENT_UNINSTALLER_VERSION_PARAM in the registry file
		echo "Modifying AGENT_UNINSTALLER_VERSION_PARAM in the registry file" >> $LOG
		./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_UNINSTALLER_VERSION_PARAM $AGENT_UNINSTALLER_VERSION
		value=$?
		if [ $value -ne 1 ]; then
			echo "Unable to write $UNINSTALLER_VERSION_PARAM to the registry file. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	if [ $AGENT_MONITORING_UPGRADE_FLAG -eq 0 ]; then
		# Modifying of AGENT_MONITORING_VERSION_PARAM in the registry file
		echo "Modifying AGENT_MONITORING_VERSION_PARAM in the registry file" >> $LOG
		./config_utility -sm $REGISTRY_FILE $VERSION_NAME $AGENT_MONITORING_VERSION_PARAM $AGENT_MONITORING_VERSION
		value=$?
		if [ $value -ne 1 ]; then
			echo "Unable to write $AGENT_MONITORING_VERSION_PARAM to the registry file. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	# Check Cron Path For Modification
	
	TASK_COMMAND_MONITORING="$InstallDir/NA_AGENT/BIN/restart_agent_monitoring.sh"
	
	TASK_COMMAND_RESTART_MONITORING="$InstallDir/NA_AGENT/BIN/restart_agent_monitoring.sh"

	# Creating schedular entries

	echo "Creating schedular entry for monitoring service" >> $LOG

	echo "$TASK_EXEC_TIME_MONITORING $TASK_COMMAND_RESTART_MONITORING" >> $PATH_FOR_CRON_ENTRY
	value=$?
	if [ $value -ne 0 ]; then
		echo "Cron entry of restart NA_Agent and agent_monitoring at 2.00 AM failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	echo "$TASK_EXEC_TIME_MONITORING_ONREBOOT $TASK_COMMAND_MONITORING" >> $PATH_FOR_CRON_ENTRY
	value=$?
	if [ $value -ne 0 ]; then
		echo "Cron entry of Monitoring service on reboot failed. Return value: $value" | tee -a $LOG
		AbortInstall 
	fi

	RepoEntry

fi

cd $InstallDir/NA_AGENT/BIN 
./agent_monitoring_service.sh & >>$LOG 2>>$LOG
sleep 5
# echo "NA AGENT has been installed successfully on your machine." | tee -a $LOG
echo "NA AGENT has been installed successfully on your machine." >> $LOG

}

function RepoEntry()
{
	# Define new path of NA_REPO_INI 
	NA_REPO_INI="$InstallDir/NA_REPO_MANAGEMENT/CONFIG/na_repo.ini"

	cp -f $NA_REPO_INI /tmp/repo_ini.bkp

	#Check the install case and add the value in RepoEntry if it is not found delete the install case.

	REPO_ENTRY=`cat $NA_REPO_INI | grep "NUMBER_OF_LOGS" |cut -d = -f 2` 2>>$LOG
	value=$?
	if [ $value -ne 0 ];then
		echo " NUMBER_OF_LOGS entry not found in na_repo.ini file" | tee -a $LOG
		AbortInstall 
	fi

	if [ $REPO_ENTRY -lt $NUMBER_OF_LOGS ];then

		./config_utility -sm $NA_REPO_INI PATHS $NUMBER_OF_LOGS_PARAM $NUMBER_OF_LOGS
		value=$?
		if [ $value -ne 1 ];then
			echo "Unable to write $NUMBER_OF_LOGS_PARAM to the registry file. Return value: $value" | tee -a $LOG
			AbortInstall 
		fi
	fi

	COUNT=$(cat $NA_REPO_INI |grep LOG_FILE_PATH_$AGENT_INDEX |wc -l)
	if [ $COUNT -eq 0 ];then
		echo "LOG_FILE_PATH_$AGENT_INDEX=../../NA_AGENT/LOGS" >>$NA_REPO_INI
	fi

	COUNT=$(cat $NA_REPO_INI |grep REPOSITORY_FILE_PATH_$AGENT_INDEX |wc -l)
	if [ $COUNT -eq 0 ];then
		echo "REPOSITORY_FILE_PATH_$AGENT_INDEX=../../NA_AGENT/REPOSITORY" >>$NA_REPO_INI
	fi

}
BROKER_ID=$1
Status_check
Get_InstallPath
Oninit
PreInstall
OnExitInstall

