#Start NA script
#
#!/bin/bash

#It holds the installation directory of NA
InstallDir=

BROKER_ID=$1

#It holds the NA Registry directory path
REGISTRY_DIRECTORY="/etc/NA_REGISTRY"

#It holds the NA Registry file path
REGISTRY_FILE="$REGISTRY_DIRECTORY/$BROKER_ID"

#It holds the NA common registry file path
COMMON_FILE="$REGISTRY_DIRECTORY/common.txt"

if [ ! -f $COMMON_FILE ]; then
	echo "registry common file missing."
	exit
fi

InstallDir=`cat $COMMON_FILE | grep "PATH" | cut -d "=" -f2`
	
if [ ! -d $InstallDir ]; then
	echo "NA installed directory not present. Return value: $value"
	exit
fi	

InstallDir="$InstallDir/$BROKER_ID"


if [ -d "$InstallDir/NA_CM/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_CM/BIN"
	cd "$InstallDir/NA_CM/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_CM/BIN failed. Return value: $value"
	fi
	#echo "Starting NA CM"
	./na_ip_cm_$BROKER_ID -c ../CONFIG/na_cm.ini 1> "/dev/null" 2> "/dev/null" &
	
fi


if [ -d "$InstallDir/NA_FO/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_FO/BIN"
	cd "$InstallDir/NA_FO/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_FO/BIN failed. Return value: $value"
	fi
	#echo "Starting NA FO"
	./na_ip_fo_$BROKER_ID -c ../CONFIG/na_fo.ini 1> "/dev/null" 2> "/dev/null" &
	
fi


if [ -d "$InstallDir/NA_WDM/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_WDM/BIN"
	cd "$InstallDir/NA_WDM/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_WDM/BIN failed. Return value: $value"
	fi
	#echo "Starting NA WDM"
	./na_ip_wdm_$BROKER_ID -c ../CONFIG/na_wdm.ini 1> "/dev/null" 2> "/dev/null" &

fi


if [ -d "$InstallDir/NA_IPO/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_IPO/BIN"
	cd "$InstallDir/NA_IPO/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_IPO/BIN failed. Return value: $value"
	fi
	#echo "Starting NA IPO"
	./na_ip_ipo_$BROKER_ID -c ../CONFIG/na_ipo.ini 1> "/dev/null" 2> "/dev/null" &

fi


if [ -d "$InstallDir/NA_CD/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_CD/BIN"
	cd "$InstallDir/NA_CD/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_CD/BIN failed. Return value: $value"
	fi
	#echo "Starting NA CD"
	./na_ip_cd_$BROKER_ID -c ../CONFIG/na_cd.ini 1> "/dev/null" 2> "/dev/null" &
	
fi


if [ -d "$InstallDir/NA_SLBM/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_SLBM/BIN"
	cd "$InstallDir/NA_SLBM/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_SLBM/BIN failed. Return value: $value"
	fi
	#echo "Starting NA SLBM"
	./na_ip_slbm_$BROKER_ID -c ../CONFIG/na_slbm.ini 1> "/dev/null" 2> "/dev/null" &
	
fi


if [ -d "$InstallDir/NA_MF/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_MF/BIN"
	cd "$InstallDir/NA_MF/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_MF/BIN failed. Return value: $value"
	fi
	#echo "Starting NA MF"
	./na_ip_mf_$BROKER_ID -c ../CONFIG/na_mf.ini 1> "/dev/null" 2> "/dev/null" &
	
fi

if [ -d "$InstallDir/NA_COM/BIN" ]; then

	#echo "Changing directory to $InstallDir/NA_COM/BIN"
	cd "$InstallDir/NA_COM/BIN"
	value=$?
	if [ $value -ne 0 ]; then
		echo "Changing directory to $InstallDir/NA_COM/BIN failed. Return value: $value"
	fi
	#echo "Starting NA COM"
	./na_ip_com_$BROKER_ID -c ../CONFIG/na_com.ini 1> "/dev/null" 2> "/dev/null" &
	
fi
